#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "SDL.h"
#include "SDL_audio.h"
#define NUM_SOUNDS 2
struct sample{
	Uint8 *data;
	Uint32 dpos;
	Uint32 dlen;
}sounds[NUM_SOUNDS];

void mixaudio(void *unused,Uint8 *stream,int len)
{
	int i;
	Uint32 amount;
	
	for(i=0;i<NUM_SOUNDS;++i)
	{
		amount=(sounds[i].dlen-sounds[i].dpos);
		if(amount>len)
		{
			amount=len;
		}
		SDL_MixAudio(stream,&sounds[i].data[sounds[i].dpos],amount,SDL_MIX_MAXVOLUME);
		sounds[i].dpos+=amount;
	}
}
void PlaySound(char *file)
{
	int index;
	SDL_AudioSpec wave;
	Uint8 *data;
	Uint32 dlen;
	SDL_AudioCVT cvt;
	
	for(index=0;index<NUM_SOUNDS;++index)
	{
		if(sounds[index].dpos==sounds[index].dlen)
		{
			break;
		}
	}
	if(index==NUM_SOUNDS)
		return;
	
	if(SDL_LoadWAV(file,&wave,&data,&dlen)==NULL)
	{
		fprintf(stderr,"Couldn't load %s: %s\n",file,SDL_GetError());
		return;
	}
	SDL_BuildAudioCVT(&cvt,wave.format,wave.channels,wave.freq,AUDIO_S16,2,22050);
	cvt.buf=malloc(dlen*cvt.len_mult);
	memcpy(cvt.buf,data,dlen);
	cvt.len=dlen;
	SDL_ConvertAudio(&cvt);
	SDL_FreeWAV(data);
	
	if(sounds[index].data)
	{
		free(sounds[index].data);
	}
	SDL_LockAudio();
	sounds[index].data=cvt.buf;
	sounds[index].dlen=cvt.len_cvt;
	sounds[index].dpos=0;
	SDL_UnlockAudio();
}


SDL_Surface *back;
SDL_Surface *image;
SDL_Surface *screen;
SDL_Surface *planet,*planet2,*planet3;
SDL_Surface *town;
SDL_Surface *tower,*towerE;
SDL_Surface *bomb;
SDL_Surface *ball1;
/*----------------------------------------------------------*/
int period=5000;
/*----------------------------------------------------------*/
int xpos=0,ypos=0,bxpos=-100,bypos=-100;
int t1x=200,t1y=320,temp=0,succ;
int t2x=225,t2y=320;
int t3x=250,t3y=320;
int t4x=330,t4y=320;
int t5x=355,t5y=320;
int t6x=380,t6y=320;
int tstat[6]={1,1,1,1,1,1};
int level=1;

void InitImages()
{
		back=SDL_LoadBMP("IMG/bg.bmp");
		image=SDL_LoadBMP("IMG/image2.bmp");
		planet=SDL_LoadBMP("IMG/planet.bmp");planet2=SDL_LoadBMP("IMG/planet2.bmp");planet3=SDL_LoadBMP("IMG/planet3.bmp");
		town=SDL_LoadBMP("IMG/town.bmp");
		tower=SDL_LoadBMP("IMG/tower.bmp");
		towerE=SDL_LoadBMP("IMG/towerE.bmp");
		bomb=SDL_LoadBMP("IMG/rocket.bmp");
		ball1=SDL_LoadBMP("IMG/bal.bmp");
		SDL_SetColorKey(image,SDL_SRCCOLORKEY,SDL_MapRGB(image->format,255,0,255));
		SDL_SetColorKey(planet,SDL_SRCCOLORKEY,SDL_MapRGB(planet->format,255,0,255));
		SDL_SetColorKey(planet2,SDL_SRCCOLORKEY,SDL_MapRGB(planet2->format,255,0,255));
		SDL_SetColorKey(planet3,SDL_SRCCOLORKEY,SDL_MapRGB(planet3->format,255,0,255));
		SDL_SetColorKey(town,SDL_SRCCOLORKEY,SDL_MapRGB(town->format,255,0,255));
		SDL_SetColorKey(tower,SDL_SRCCOLORKEY,SDL_MapRGB(tower->format,255,0,255));
		SDL_SetColorKey(towerE,SDL_SRCCOLORKEY,SDL_MapRGB(towerE->format,255,0,255));
		SDL_SetColorKey(bomb,SDL_SRCCOLORKEY,SDL_MapRGB(bomb->format,255,0,0));
		SDL_SetColorKey(ball1,SDL_SRCCOLORKEY,SDL_MapRGB(ball1->format,255,0,0));
}
void DrawIMG(SDL_Surface *img,int x,int y)
{
	SDL_Rect dest;
	dest.x=x;
	dest.y=y;
	
	SDL_BlitSurface(img,NULL,screen,&dest);
}
void DrawIMG2(SDL_Surface *img,int x,int y,int w,int h,int sx,int sy)
{
	SDL_Rect dest;
	dest.x=x;
	dest.y=y;
	
	SDL_Rect src;
	src.x=sx;
	src.y=sy;
	src.w=w;
	src.h=h;
	
	SDL_BlitSurface(img,&src,screen,&dest);
}
void DrawBG()
{
	DrawIMG(back,0,0);
	
	if(!(level%2)){DrawIMG(planet2,70,360);}else{if(!(level%3)){DrawIMG(planet3,70,360);}else{DrawIMG(planet,70,360);}}
	
	DrawIMG(town,280,390);
	DrawIMG(tower,200,390);
	DrawIMG(tower,225,390);
	DrawIMG(tower,250,390);
	DrawIMG(tower,330,390);
	DrawIMG(tower,355,390);
	DrawIMG(tower,380,390);
}
void DrawScene()
{
	DrawIMG2(back,xpos-2,ypos-2,60,60,xpos-2,ypos-2);
	if(bypos<=340){DrawIMG2(back,bxpos-2,bypos-2,40,40,bxpos-2,bypos-2);DrawIMG(bomb,bxpos,bypos);}
	DrawIMG2(back,t1x-2,t1y-2,35,35,t1x-2,t1y-2);
	DrawIMG(ball1,t1x,t1y);
	DrawIMG2(back,t2x-2,t2y-2,35,35,t2x-2,t2y-2);
	DrawIMG(ball1,t2x,t2y);
	DrawIMG2(back,t3x-2,t3y-2,35,35,t3x-2,t3y-2);
	DrawIMG(ball1,t3x,t3y);
	DrawIMG2(back,t4x-2,t4y-2,35,35,t4x-2,t4y-2);
	DrawIMG(ball1,t4x,t4y);
	DrawIMG2(back,t5x-2,t5y-2,35,35,t5x-2,t5y-2);
	DrawIMG(ball1,t5x,t5y);
	DrawIMG2(back,t6x-2,t6y-2,35,35,t6x-2,t6y-2);
	DrawIMG(ball1,t6x,t6y);
	DrawIMG(image,xpos,ypos);
	SDL_Flip(screen);
}

int main(int argc,char *argv[])
{
	
	Uint8* keys;
	
	if(SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO)<0)
	{
		printf("Unable to init SDL: %s\n",SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);
	
	screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
	if(screen==NULL)
	{
		printf("Unable to set 640x480 video: %s\n",SDL_GetError());
		exit(1);
	}
	
	{
		extern void mixaudio(void *unused,Uint8 *stream,int len);
		SDL_AudioSpec fmt;
		
		fmt.freq=22050;
		fmt.format=AUDIO_S16;
		fmt.channels=2;
		fmt.samples=512;
		fmt.callback=mixaudio;
		fmt.userdata=NULL;
		
		if(SDL_OpenAudio(&fmt,NULL)<0)
		{
			printf("Unable to open Audio: %s\n",SDL_GetError());
			exit(1);
		}
		SDL_PauseAudio(0);
	}
	
	InitImages();
	DrawBG();
	PlaySound("IMG/bg.wav");
	int done=0,bomb=0,bbal1=1,bbal2=1,bbal3=1,bbal4=1,bbal5=1,bbal6=1;//,pause=0;
	while(done==0){
		
		SDL_Event event;
		
		while(SDL_PollEvent(&event))
		{
			if(event.type==SDL_QUIT){done=1;}
			if(event.type==SDL_KEYDOWN)
			{
				if(event.key.keysym.sym==SDLK_ESCAPE){done=1;}
			}
		}
		if((xpos>=t1x-20&&xpos<=t1x+20)&&(ypos>=t1y-20&&ypos<=t1y+20)){done=1;}
		if((xpos>=t2x-20&&xpos<=t2x+20)&&(ypos>=t2y-20&&ypos<=t2y+20)){done=1;}
		if((xpos>=t3x-20&&xpos<=t3x+20)&&(ypos>=t3y-20&&ypos<=t3y+20)){done=1;}
		if((xpos>=t4x-20&&xpos<=t4x+20)&&(ypos>=t4y-20&&ypos<=t4y+20)){done=1;}
		if((xpos>=t5x-20&&xpos<=t5x+20)&&(ypos>=t5y-20&&ypos<=t5y+20)){done=1;}
		if((xpos>=t6x-20&&xpos<=t6x+20)&&(ypos>=t6y-20&&ypos<=t6y+20)){done=1;}
		if(done){printf("\nGame over!\n");}
		
		if((bxpos>=190&&bxpos<=210)&&bypos==339&&tstat[0]==1){tstat[0]=0;temp-=period;DrawIMG(towerE,200,390);}
		if((bxpos>=215&&bxpos<=235)&&bypos==339&&tstat[1]==1){tstat[1]=0;temp-=period;DrawIMG(towerE,225,390);}
		if((bxpos>=240&&bxpos<=260)&&bypos==339&&tstat[2]==1){tstat[2]=0;temp-=period;DrawIMG(towerE,250,390);}
		if((bxpos>=320&&bxpos<=340)&&bypos==339&&tstat[3]==1){tstat[3]=0;temp-=period;DrawIMG(towerE,330,390);}
		if((bxpos>=345&&bxpos<=365)&&bypos==339&&tstat[4]==1){tstat[4]=0;temp-=period;DrawIMG(towerE,355,390);}
		if((bxpos>=370&&bxpos<=390)&&bypos==339&&tstat[5]==1){tstat[5]=0;temp-=period;DrawIMG(towerE,380,390);}
		
		//printf("\n%i\n",tstat[0]);
		if((bxpos>=280&&bxpos<=310)&&bypos>=335&&!tstat[0]&&!tstat[1]&&!tstat[2]&&!tstat[3]&&!tstat[4]&&!tstat[5])
		{
			
			
			level++;
			printf("\n################\nLevel %i\n################\n",level);
			DrawIMG2(back,xpos-2,ypos-2,60,60,xpos-2,ypos-2);
			DrawBG();
			xpos=0;
			ypos=0;
			tstat[0]=1;tstat[1]=1;tstat[2]=1;tstat[3]=1;tstat[4]=1;tstat[5]=1;
			period-=(period/100)*30;
			temp=(period/100)*80;
		}
		
		/*int xtemp;
		while(pause)
		{
			xtemp=500;while(xtemp){xtemp--;}
			if(keys[SDLK_PAUSE]){pause=0;}
		}*/
		//f(!bbal1){bbal1=1;t1x=280;t1y=340;
		//	temp[0]=xpos-t1x;temp[1]=ypos-t1y;temp[2]=fabs(temp[0]);temp[3]=fabs(temp[1]);temp[2]=temp[0]/temp[2];temp[3]=temp[3]/temp[1];
		//	}
		//if(bbal1&&t1x<temp[0]&&t1y<temp[1]){t1x+=temp[2];t1y+=temp[3];}else{bbal1=0;t1x=-100;t1y=-100;}
		if(t2y<=0){bbal2=0;DrawIMG2(back,t2x-2,t2y-2,35,35,t2x-2,t2y-2);t2y=-100;t2x=-100;}
		if(temp==(period-50)){tstat[1]==1;bbal2=1;t2y=320;t2x=225;}
		if(bbal2){DrawIMG(tower,225,390);t2y--;if((rand())%2){t2x++;}else{t2x--;}}
		
		if(t3y<=0){bbal3=0;DrawIMG2(back,t3x-2,t3y-2,35,35,t3x-2,t3y-2);t3y=-100;t3x=-100;}
		if(temp==(period-100)){tstat[2]==1;bbal3=1;t3y=320;t3x=250;}
		if(bbal3){DrawIMG(tower,250,390);t3y--;if((rand())%2){t3x++;}else{t3x--;}}
		
		if(t4y<=0){bbal4=0;DrawIMG2(back,t4x-2,t4y-2,35,35,t4x-2,t4y-2);t4y=-100;t4x=-100;}
		if(temp==(period-100)){tstat[3]==1;bbal4=1;t4y=320;t4x=330;}
		if(bbal4){DrawIMG(tower,330,390);t4y--;if((rand())%2){t4x++;}else{t4x--;}}
		
		if(t5y<=0){bbal5=0;DrawIMG2(back,t5x-2,t5y-2,35,35,t5x-2,t5y-2);t5y=-100;t5x=-100;}
		if(temp==(period-50)){tstat[4]==1;bbal5=1;t5y=320;t5x=355;}
		if(bbal5){DrawIMG(tower,355,390);t5y--;if((rand())%2){t5x++;}else{t5x--;}}
		
		if(t6y<=0){bbal6=0;DrawIMG2(back,t6x-2,t6y-2,35,35,t6x-2,t6y-2);t6y=-100;t6x=-100;}
		if(temp==(period-1)){tstat[5]==1;bbal6=1;t6y=320;t6x=380;}
		if(bbal6){DrawIMG(tower,380,390);t6y--;if((rand())%2){t6x++;}else{t6x--;}}
		
		if(t1y<=0){bbal1=0;DrawIMG2(back,t1x-2,t1y-2,35,35,t1x-2,t1y-2);t1y=-100;t1x=-100;}
		temp++;if(temp==period){tstat[0]==1;bbal1=1;temp=0;t1y=320;t1x=200;}
		if(bbal1){DrawIMG(tower,200,390);t1y--;if((rand())%2){t1x++;}else{t1x--;}}
		
		
		
		
		if(bomb){bypos++;}
		if(bypos>=340){DrawIMG2(back,bxpos-2,bypos-2,40,40,bxpos-2,bypos-2);bomb=0;bypos=-100;bxpos=-100;}
		keys=SDL_GetKeyState(NULL);
		if(keys[SDLK_UP]&&ypos>=0){ypos-=1;}
		if(keys[SDLK_DOWN]&&ypos<=300){ypos+=1;}
		if(keys[SDLK_LEFT]&&xpos>=0){xpos-=1;}
		if(keys[SDLK_RIGHT]&&xpos<=590){xpos+=1;}
		if(keys[SDLK_TAB]){DrawIMG2(back,bxpos-2,bypos-2,40,40,bxpos-2,bypos-2);bxpos=xpos+5;bypos=ypos+40;bomb=1;}
		
		
		//if(keys[SDLK_SPACE]){pause=1;}
		
		DrawScene();
	}
	SDL_CloseAudio();
	return 0;
}
